
import java.util.*;
import java.io.*;

public class battleship_font
{
   public static void main(String[] args) throws Exception
   {
      PrintWriter out = new PrintWriter(System.out);
      new battleship_font(new FastScanner(System.in), out);
      out.close();
   }

   int res;
   int N, K;
   char[][] mark;
   boolean[][] hasShip;
   boolean[] placedShip;
   int[] lengths;

   int[] dr = {1, 0};
   int[] dc = {0, 1};

   boolean place(int i, int j, int dir, int k)
   {
      if (placedShip[k])
         return false;
      
      int len = lengths[k];
      // I feel this is wrong...
      if (dir == 1 && len == 1)
         return false;

      if (i + dr[dir] * len > N || j + dc[dir] * len > N)
         return false;

      for (int u=0; u<len; u++)
      {
         int ni = i + dr[dir] * u;
         int nj = j + dc[dir] * u;
         if (hasShip[ni][nj])
            return false;
         if (mark[ni][nj] == 'X')
            return false;
      }

      placedShip[k] = true;

      for (int u=0; u<len; u++)
      {
         int ni = i + dr[dir] * u;
         int nj = j + dc[dir] * u;
         hasShip[ni][nj] = true;
      }

      return true;
   }

   void unplace(int i, int j, int dir, int k)
   {
      int len = lengths[k];
      for (int u=0; u<len; u++)
      {
         int ni = i + dr[dir] * u;
         int nj = j + dc[dir] * u;
         hasShip[ni][nj] = false;
      }

      placedShip[k] = false;
   }

   void go(int i, int j, int shipCount)
   {
      if (i == N)
      {
         if (shipCount == K)
            res++;
         return;
      }
      if (j == N)
      {
         go(i+1, 0, shipCount);
         return;
      }
      if (hasShip[i][j])
      {
         go(i, j+1, shipCount);
         return;
      }

      if (mark[i][j] != 'O')
      {
         go(i, j+1, shipCount);
      }

      for (int dir=0; dir<2; dir++)
      {
         for (int k=0; k<K; k++)
         {
            if (place(i, j, dir, k))
            {
               go(i, j+1, shipCount+1);
               unplace(i, j, dir, k);
            }
         }
      }
   }

   public battleship_font(FastScanner in, PrintWriter out)
   {
      N = in.nextInt();
      K = in.nextInt();
      mark = new char[N][];
      hasShip = new boolean[N][N];
      placedShip = new boolean[K];
      for (int i=0; i<N; i++)
         mark[i] = in.next().toCharArray();

      lengths = new int[K];
      for (int i=0; i<K; i++)
         lengths[i] = in.nextInt();
      

      res = 0;
      go(0, 0, 0);

      out.println(res);
   }
}

class FastScanner
{
   private InputStream stream;
   private byte[] buf = new byte[1024];
   private int curChar;
   private int numChars;
    
   public FastScanner(InputStream stream)
   {
      this.stream = stream;
   }
    
   int read()
   {
      if (numChars == -1)
         throw new InputMismatchException();
      if (curChar >= numChars)
      {
         curChar = 0;
         try
         {
            numChars = stream.read(buf);
         } 
         catch (IOException e) 
         {
            throw new InputMismatchException();
         }
         
         if (numChars <= 0)
            return -1;
      }
      return buf[curChar++];
   }
    
   boolean isSpaceChar(int c)
   {
      return c==' '||c=='\n'||c=='\r'||c=='\t'||c==-1;
   }
   
   boolean isEndline(int c)
   {
      return c=='\n'||c=='\r'||c==-1;
   }
   
   int nextInt()
   {
      return Integer.parseInt(next());
   }
   
   long nextLong()
   {
      return Long.parseLong(next());
   }
   
   double nextDouble()
   {
      return Double.parseDouble(next());
   }
   
   String next()
   {
      int c = read();
      while (isSpaceChar(c))
         c = read();
      StringBuilder res = new StringBuilder();
      do
      {
         res.appendCodePoint(c);
         c = read();
      } while(!isSpaceChar(c));
      return res.toString();
   }
   
   String nextLine()
   {
      int c = read();
      while (isEndline(c))
         c = read();
      
      StringBuilder res = new StringBuilder();
      do
      {
         res.appendCodePoint(c);
         c = read();
      } while(!isEndline(c));
      return res.toString();
   }
}
